require 'spec_helper'

describe Customize::Formulaic do

	with_model :product do
		table do |t|
		end
		model do
			include Customize::Formulaic
		end
	end

	with_model :instance do
	end

	subject { Product.create }

	context :formulaic_model do
		it :has_formulars do
			subject.formulars.should be_empty
		end
	end

	context :forumular do
		subject { Customize::Formular.create :calculator_name=>Customize::Calculator::ExpressionCalculator.name }

		it "has calculator" do
			subject.calculator.should be_a(Customize::Calculator::ExpressionCalculator)
		end

		it "store input value" do
			subject.calculator_attributes = {"expression"=>1}
			subject.save
			subject.reload
			subject.calculator.expression.should == 1
		end
	end

	context :expression_calculator do
		it "1+1=2" do
			calculator = Customize::Calculator::ExpressionCalculator.new
			calculator.expression = "1 + 1"
			calculator.calculate(Instance.new).should == 2
		end
	end

end
